﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;
using Microsoft.Crm.Workflow;
using System.Workflow.ComponentModel.Compiler;
using Microsoft.Crm.Sdk;
using Microsoft.Crm.Sdk.Query;
using Microsoft.Crm.SdkTypeProxy;

namespace CrmContrib.Workflow.Activities.Marketing
{
    [CrmWorkflowActivity("Add Contact to Marketing List", "CrmContrib \\ Marketing")]
    public class AddContactToMarketingListActivity : Activity
    {
        [CrmInput("Contact")]
        [CrmReferenceTarget("contact")]
        [ValidationOption(ValidationOption.Required)]
        public Lookup Contact
        {
            get { return (Lookup)base.GetValue(AddContactToMarketingListActivity.ContactProperty); }
            set { base.SetValue(AddContactToMarketingListActivity.ContactProperty, value); }
        }

        public static readonly DependencyProperty ContactProperty = DependencyProperty.Register("Contact", typeof(Lookup), typeof(AddContactToMarketingListActivity));

        [CrmInput("Marketing List")]
        [CrmReferenceTarget("list")]
        [ValidationOption(ValidationOption.Required)]
        public Lookup MarketingList
        {
            get { return (Lookup)GetValue(MarketingListProperty); }
            set { SetValue(MarketingListProperty, value); }
        }

        public static readonly DependencyProperty MarketingListProperty = DependencyProperty.Register("MarketingList", typeof(Lookup), typeof(AddContactToMarketingListActivity));

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            var contextService = executionContext.GetService<IContextService>();
            var workflowContext = contextService.Context;
            var crmService = workflowContext.CreateCrmService();

            var addRequest = new AddMemberListRequest();
            addRequest.EntityId = this.Contact.Value;
            addRequest.ListId = this.MarketingList.Value;

            var addResponse = (AddMemberListResponse)crmService.Execute(addRequest);

            return base.Execute(executionContext);
        }
    }
}
